﻿Imports System.Windows.Forms
Public Class Login
    Inherits Form
    ' members
    Public Tries As Integer
    Public MaxTries As Integer
    Public UserId As Integer

    'events
    Event LoginFailed(ByVal sender As Object, ByVal e As EventArgs)
    Event LoginSucceeded(ByVal sender As Object, _
                         ByVal e As LoginSucceededEventArgs)
    Event LoginCancelled(ByVal sender As Object, ByVal e As EventArgs)
    ' Go - authenticated the username and password
    Public Function Go(ByVal owner As Form) As Integer
        'reset
        UserId = 0
        Tries = 0
        ' show
        Me.ShowDialog(owner)
        ' return the UserId number
        Return UserId
    End Function

    ' Go straight to Select Test page without logging in.
    Private Sub btnGuest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGuest.Click
        ' open Select Test page.
        Dim oForm As SelectTest
        oForm = New SelectTest()
        oForm.Show()
        oForm = Nothing
    End Sub

    Private Sub btnLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLogin.Click
        ' check that the username field is filled.
        If cboUsername.Text.Trim.Length > 0 Then
            ' TODO: check that the password is correct.
            ' For now... the password is 'racer'
            If txtPassword.Text = "racer" Then
                ' TODO: user logs in.  hooray!
                UserId = 1
                ' new event
                Dim newEventArgs As New LoginSucceededEventArgs()
                newEventArgs.UserId = UserId
                RaiseEvent LoginSucceeded(Me, newEventArgs)
                ' hide the dialog and return
                Me.DialogResult = DialogResult.OK

                ' go to the user's profile page
                Dim oForm As Profile
                oForm = New Profile()
                oForm.Show()
                oForm = Nothing
            Else
                ' tell the user that the password was incorrect
                MessageBox.Show("The password you entered is incorrect.  Please try again.")
                ' tell the caller that the login failed.
                RaiseEvent LoginCancelled(Me, New EventArgs())
                ' TODO: Do we want to limit the number of login attempts?
                ' For now... number of attempts is 3
                ' add one to the number of tries.
                Tries += 1
                If Tries = MaxTries Then
                    Me.DialogResult = DialogResult.OK
                End If
        End If
        Else
            MessageBox.Show("You must enter a username.")
        End If
    End Sub
End Class