﻿Imports Microsoft.Office.Interop
Imports Forms_Library

' Select Test - Users choose a category and a level from the drop down boxes and open the testing
' page for either a record test or a practice test.
Public Class SelectTest
    ' members...
    Public allProblems As New ArrayList

    Public CategoryChoice As String
    Public LevelChoice As String ' Turn this into an Integer?
    Public Practice As Boolean ' indicator flag for practice tests
    Private _userId As Integer
    Private WithEvents _login As Forms_Library.LoginUser

    ' login succeeded, the captian changes to reflect the logged in user
    Private Sub _login_LoginSucceeded(ByVal sender As System.Object, _
                                      ByVal e As Forms_Library.LoginSucceededEventArgs) Handles _login.LoginSucceeded
        ' store the user id
        _userId = e.UserId
        ' update the caption
        ' TODO: figure out how you want to display the user name
        ' TODO: get the user Id's name
        Me.Text &= " - User ID: " & _userId.ToString
    End Sub

    ' login instance
    Private Function Login() As Boolean
        ' create an instance of login...
        _login = New Forms_Library.LoginUser()
        ' login the user
        Dim userId As Integer = _login.Go(Me)
        ' reset the login object
        _login = Nothing
        ' return true or false
        If userId <> 0 Then
            Return True
        Else
            Return False
        End If
    End Function

    ' Login button - go to log in page.
    Private Sub btnLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLogin.Click
        ' create a new instance of the form
        Dim login As New Forms_Library.LoginUser()
        ' get the user id back
        Dim userId As Integer = login.Go(Me)
        ' For now... Check: did we get a user?
        If userId <> 0 Then
            MessageBox.Show("The logged in user has Id " & userId.ToString)
        Else
            MessageBox.Show("No User ID was returned.")
        End If
    End Sub

    ' Select Category - when the user selects a category from the dropdown, the options in the Level
    ' dropdown should be updated
    Private Sub cboCategory_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboCategory.SelectedIndexChanged
        Dim intSelectedIndex As Integer
        intSelectedIndex = cboCategory.SelectedIndex
        Dim objSelectedItem As Object
        objSelectedItem = cboCategory.SelectedIndex

        Dim comboBox As ComboBox = CType(sender, ComboBox)
        ' Save selected category
        Dim selectedIndex = CType(cboCategory.SelectedIndex, String)

        ' TODO: get the list of levels for selected category

        ' For now... the lists are levels 1-5 and 1-2
        Dim forNowLevels1() As String
        forNowLevels1 = New String() {"Level 1", _
                                      "Level 2", _
                                      "Level 3", _
                                      "Level 4", _
                                      "Level 5"}
        Dim forNowLevels2() As String
        forNowLevels2 = New String() {"Level 1", _
                                      "Level 2"}

        ' For now.. This is just a test...
        ' MessageBox.Show("Woot!  You don't entirely fail at life!")

        Dim addition As String
        addition = "Addition"
        Dim intResult As Integer
        intResult = StrComp(addition, selectedIndex, vbTextCompare)
        'MessageBox.Show("If the result is Zero, we can do math:" & intResult)

        If intResult = 0 Then
            ' display list 1
            MessageBox.Show("You got into the addition loop.")
            cboLevel.Items.AddRange(forNowLevels1)
        End If
    End Sub

    ' Record Test - open Testing Page to begin record test with the selected category and level
    Private Sub btnRecordTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRecordTest.Click
        ' check that a category was selected
        If cboCategory.Text.Length > 0 Then
            ' check that a level was selected
            If cboLevel.Text.Length > 0 Then
                ' set the Category and Level
                CategoryChoice = cboCategory.Text
                LevelChoice = cboLevel.Text
                ' Indicate that this is a record test
                Practice = False
                ' Open the Testing Page
                ' open Testing Page.
                Dim oForm As TestingPage
                oForm = New TestingPage()
                oForm.Show()
                oForm = Nothing
            Else
                ' tell the user that the level hasn't been chosen
                MessageBox.Show("Please choose a level.")
            End If
        Else
            ' tell the user that the category hasn't been chosen
            MessageBox.Show("Please choose a category.")
        End If
    End Sub

    ' Practice Test - open Testing Page to begin practice test with the selected category and level
    Private Sub btnPracticeTest_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPracticeTest.Click
        ' check that a category was selected
        If cboCategory.Text.Length > 0 Then
            ' check that a level was selected
            If cboLevel.Text.Length > 0 Then
                ' set the Category and Level
                CategoryChoice = cboCategory.Text
                LevelChoice = cboLevel.Text
                ' Indicate that this is a record test
                Practice = True
                ' open testing page.
                Dim oForm As TestingPage
                oForm = New TestingPage()
                oForm.Show()
                oForm = Nothing
            Else
                ' tell the user that the level hasn't been chosen
                MessageBox.Show("Please choose a level.")
            End If
        Else
            ' tell the user that the category hasn't been chosen
            MessageBox.Show("Please choose a category.")
        End If
    End Sub

    ' Load the Select Test page - automatically go to the Login Page
    Private Sub SelectTest_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Try and login
        If Login() = False Then
            ' quit the application if we failed
            MessageBox.Show("Login failed.  Quitting.")
            Application.Exit()
        End If

        xcelInit()

    End Sub
    ' TODO: make the menu a control
    ' Login menu button - go to the login page
    Private Sub LoginLogoutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoginLogoutToolStripMenuItem.Click
        ' create a new instance of the form
        Dim login As New Forms_Library.LoginUser()
        ' get the user id back
        Dim userId As Integer = login.Go(Me)
        ' For now... Check: did we get a user?
        If userId <> 0 Then
            MessageBox.Show("The logged in user has Id " & userId.ToString)
        Else
            MessageBox.Show("No User ID was returned.")
        End If
    End Sub
    ' New Test menu button - open Select Test page
    Private Sub NewTestToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewTestToolStripMenuItem.Click
        ' open Select Test
        Dim oForm As SelectTest
        oForm = New SelectTest()
        oForm.Show()
        oForm = Nothing
    End Sub
    Public Sub xcelInit()
        Dim xl As New Excel.Application
        Dim xlsheet As New Excel.Worksheet
        Dim xlwbook As Excel.Workbook
        xlwbook = xl.Workbooks.Open("C:\Documents and Settings\Andrea DeMelo\My Documents\Book1.xlsx")
        xlsheet = xlwbook.Worksheets("Sheet1")
        For Each cell In xlsheet.Cells
            Dim temp As New MathProblem
            If (cell.Value <> "") Then
                MessageBox.Show(cell.Value)
                temp.original = cell.Value
                temp.getInternals()
                MessageBox.Show(temp.original.ToString)
                allProblems.Add(temp)
            End If
            If cell.Value = "" Then GoTo ESCAPE
            MessageBox.Show("AAAAHHHHH")
        Next
        MessageBox.Show("I am in here...HHEEELLLPPPP!!!" + allProblems.ToString)
ESCAPE:
    End Sub
    ' Exit Program menu button -  Close the program
    ' TODO: figure out what closing the program entails.
    Private Sub ExitProgramToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitProgramToolStripMenuItem.Click

    End Sub
    ' Profile Page menu button - go to the user's profile page
    Private Sub ProfilePageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProfilePageToolStripMenuItem.Click
        ' check that the user is logged in
        If _userId <> 0 Then
            ' open Profile Page
            ' TODO: write this.
        End If

    End Sub



End Class
